/*
 *   kvideolist - a database for home-movie collections
 *   Copyright (C) 1998  Holger Hetterich
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or           *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
                                       
#include <stdio.h>
#include <stdlib.h>
#include <qfiledlg.h>

#include "setattrib.moc"



Attributes::Attributes(QWidget *parent, const char *name):QDialog(parent,name,TRUE) {
	this->setCaption(klocale->translate("Set Attributes"));
	this->resize(650,150);

SetLongPlay = new QComboBox(this,"1");
SetLongPlay->move(10,10);
SetLongPlay->resize(150,20);
SetLongPlay->insertItem(klocale->translate("Ignore LongPlay"),0);
SetLongPlay->insertItem(klocale->translate("Longplay on"),1);
SetLongPlay->insertItem(klocale->translate("Longplay off"),2);

SetStereo = new QComboBox(this,"2");
SetStereo->move(10+150+10,10);
SetStereo->resize(150,20);
SetStereo->insertItem(klocale->translate("Ignore Stereo"),0);
SetStereo->insertItem(klocale->translate("Stereo on"),1);
SetStereo->insertItem(klocale->translate("Stereo off"),2);

SetMovieText = new QComboBox(this,"2");
SetMovieText->move(10+150+10+150+10,10);
SetMovieText->resize(150,20);
SetMovieText->insertItem(klocale->translate("Ignore MovieText"),0);
SetMovieText->insertItem(klocale->translate("MovieText on"),1);
SetMovieText->insertItem(klocale->translate("MovieText off"),2);

SetColor = new QComboBox(this,"2");
SetColor->move(10+150+10+150+10+150+10,10);
SetColor->resize(150,20);
SetColor->insertItem(klocale->translate("Ignore Color"),0);
SetColor->insertItem(klocale->translate("Color on"),1);
SetColor->insertItem(klocale->translate("Color off"),2);

SetSubClass = new QComboBox(this,"2");
SetSubClass->move(10,40);
SetSubClass->resize(150,20);
SetSubClass->insertItem(klocale->translate("Ignore Subclass"),0);
SetSubClass->insertItem(klocale->translate("Set to no Subclass"),1);

SetAutoURL= new QComboBox(this,"2");
SetAutoURL->move(10+150+10,40);
SetAutoURL->resize(150,20);
SetAutoURL->insertItem(klocale->translate("Ignore URL Auto"),0);
SetAutoURL->insertItem(klocale->translate("URL Auto-open on"),1);
SetAutoURL->insertItem(klocale->translate("URL Auto-open off"),2);

SetComments = new QComboBox(this,"2");
SetComments->move(10+150+10+150+10,40);
SetComments->resize(150,20);
SetComments->insertItem(klocale->translate("Ignore clear text"),0);
SetComments->insertItem(klocale->translate("Clear text"),1);

SetURL = new QComboBox(this,"2");
SetURL->move(10+150+10+150+10+150+10,40);
SetURL->resize(150,20);
SetURL->insertItem(klocale->translate("Ignore clear URL"),0);
SetURL->insertItem(klocale->translate("Clear URL"),1);
SetSurround= new QComboBox(this,"2");
SetSurround->move(10,70);
SetSurround->resize(150,20);
SetSurround->insertItem(klocale->translate("Ignore Surround"),0);
SetSurround->insertItem(klocale->translate("Surround on"),1);
SetSurround->insertItem(klocale->translate("Surround off"),2);

SetRanking= new QComboBox(this,"2");
SetRanking->move(10+150+10,70);
SetRanking->resize(150,20);

SetRanking->insertItem(klocale->translate("Ignore Ranking"),0);
SetRanking->insertItem("1 = worst",1);
SetRanking->insertItem("2",2);
SetRanking->insertItem("3",3);
SetRanking->insertItem("4",4);
SetRanking->insertItem("5",5);
SetRanking->insertItem("6",6);
SetRanking->insertItem("7",7);
SetRanking->insertItem("8",8);
SetRanking->insertItem("9",9);
SetRanking->insertItem("10 = best",10);


SetRanking->setFont(QFont("Times",12));
SetAutoURL->setFont(QFont("Times",12));
SetSurround->setFont(QFont("Times",12));
SetStereo->setFont(QFont("Times",12));
SetMovieText->setFont(QFont("Times",12));
SetURL->setFont(QFont("Times",12));
SetComments->setFont(QFont("Times",12));
SetLongPlay->setFont(QFont("Times",12));
SetColor->setFont(QFont("Times",12));
SetSubClass->setFont(QFont("Times",12));




QPushButton *OK = new QPushButton("Ok",this);
OK->adjustSize();
OK->move(10,100);
connect(OK,SIGNAL(clicked()),SLOT(accept()));



};

	
